"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.usePopupPlugin = void 0;
var usePopupPlugin = exports.usePopupPlugin = function usePopupPlugin(_ref) {
  var ast = _ref.ast,
    t = _ref.t,
    traverse = _ref.traverse,
    store = _ref.store;
  traverse(ast, {
    ExportDefaultDeclaration: function ExportDefaultDeclaration(path) {
      var declaration = path.node.declaration;
      if (!t.isClassDeclaration(declaration)) {
        return;
      }
      var superClass = declaration.superClass;
      if (!t.isIdentifier(superClass)) {
        return;
      }
      var name = superClass.name;
      if (name !== 'Popup') {
        return;
      }
      var getParams = function getParams() {
        if (t.isTSTypeParameterInstantiation(declaration.superTypeParameters)) {
          var param = declaration.superTypeParameters.params[0];
          if (t.isTSVoidKeyword(param)) {
            return [];
          }
          var identifier = t.identifier('close');
          identifier.typeAnnotation = t.tsTypeAnnotation(param);
          return [identifier];
        }
        return [];
      };
      var close = t.objectProperty(t.identifier('type'), t.tsAsExpression(t.identifier('Function'), t.tsTypeReference(t.identifier('PropType'), t.tsTypeParameterInstantiation([t.tsFunctionType(undefined, getParams(), t.tsTypeAnnotation(t.tsVoidKeyword()))]))));
      var defaultProperty = t.objectProperty(t.identifier('default'), t.arrowFunctionExpression(getParams(), t.blockStatement([])));
      var res = t.objectProperty(t.identifier('close'), t.objectExpression([close, defaultProperty]));
      store.addProp('close', res);
      store.addPropName('close');
      store.addExcludesNamesImportSpecifier('Popup');
    }
  });
};