"use strict";

function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.replaceWatchDecorator = void 0;
var t = _interopRequireWildcard(require("@babel/types"));
var _traverse = _interopRequireDefault(require("@babel/traverse"));
var _store = _interopRequireDefault(require("../store"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
// vue-property-decorator
// @Watch(path: string, options: WatchOptions = {})
var replaceWatchDecorator = exports.replaceWatchDecorator = function replaceWatchDecorator(ast) {
  (0, _traverse["default"])(ast, {
    Decorator: function Decorator(path) {
      var expression = path.node.expression;
      if (!t.isCallExpression(expression)) {
        return;
      }
      if (!t.isIdentifier(expression.callee) || expression.callee.name !== 'Watch') {
        return;
      }
      var args = expression.arguments;
      var key = args[0];
      var options = args[1];
      if (!key || !t.isStringLiteral(key)) {
        return;
      }
      var target = _store["default"].hasPropName(key.value) ? t.memberExpression(t.identifier('props'), t.identifier(key.value)) : t.memberExpression(t.identifier(key.value), t.identifier('value'));
      var bodyName = path.parent.key.name;
      var callArguments = [t.arrowFunctionExpression([], target), t.identifier(bodyName)];
      if (options && t.isObjectExpression(options)) {
        callArguments.push(options);
      }
      var watch = t.expressionStatement(t.callExpression(t.identifier('watch'), callArguments));
      _store["default"].addAfterSetupStatement(watch);
      _store["default"].addImport('vue', 'watch');
    }
  });
};